/* 
* Copyright 1998-2014 VIA Technologies, Inc. All Rights Reserved.
* Copyright 2001-2014 S3 Graphics, Inc. All Rights Reserved.
* Copyright 2013-2014 Shanghai Zhaoxin Semiconductor Co., Ltd. All Rights Reserved.
*
* This file is part of zx.ko
* 
* zx.ko is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* zx.ko is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef __S3G_IOCTL_COMPAT_H__
#define __S3G_IOCTL_COMPAT_H__ 

#include"s3.h"
#include"s3g_def.h"
#include"s3g_driver.h"

extern int s3g_ioctl_get_busid(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_display_info(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_iga_info(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_addctx(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_rmctx(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_lock_ctx(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_unlock_ctx(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_clip_notify_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_add_drawable_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_remove_drawable(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_drawsize(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_query_display_caps(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_query_output_caps_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_set_mode(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_cursor(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_gamma_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_dpms(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_mode_timing(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_2d_init(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_init_screen_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_deinit_screen_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_wait_chip_idle(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_escape_call_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_2d_draw_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_acquire_aperture(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_release_aperture(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_leave_vt(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_enter_vt(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_check_device_combination(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_set_ps(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_enum_sub_device(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_create_allocation(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_open_allocation(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_destroy_allocation(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_lock_allocation_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_unlock_allocation(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_flush_allocation(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_wait_allocation_idle(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_video_get_hw_caps(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_get_address_config_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_query_info(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_wait_func(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_flip(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_cec_ctl(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_present(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_drawable_surface(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_vsync_cnt(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_create_device(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_destroy_device(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_begin_perf_event(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_end_perf_event(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_get_perf_event_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_send_perf_event(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_perf_status(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_begin_miu_dump_perf_event(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_end_miu_dump_perf_event(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_set_miu_reg_list_perf_event_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_get_miu_dump_perf_event_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_direct_get_miu_dump_perf_event_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_create_context_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_destroy_context(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_wait_context_idle(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_render_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_query_chip_id(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_hdcp_op(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_create_fence_sync_object(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_destroy_fence_sync_object(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_wait_fence_sync_object(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_fence_value(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_create_fence_fd(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_flip_limit(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_ipc_operation_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_create_stream(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_destroy_stream(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_display_frame(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_set_interactive(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
//extern int s3g_ioctl_send_dsi_cmd_compat(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_mhl_cbus_send_command(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_create_di_context(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_destroy_di_context(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_register_mhl_callback(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_set_power_perf_mode(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_device_comb(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_gfx_stm(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_hdmi_audio_format(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_hpd_info(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_handle_to_fd(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_fd_to_handle(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_ust_msc(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_get_allocation_state(s3g_file_t* priv, unsigned int cmd, unsigned long arg);
extern int s3g_ioctl_wait_event(s3g_file_t* priv, unsigned int cmd, unsigned long arg);

typedef struct s3g_clipnotify_compat
{
    int x;
    int y;
    int width;
    int height;

    short screen_x;
    short screen_y;

    int numClipRects;
    int xId;
    unsigned int kdrawId;
    int scrnIndex;
    int iga_mask;
    unsigned int hAllocation;

    compat_uptr_t clipRects;
    /* How many clipRects knl malloc */
    int clipRectsVol;
}s3g_clipnotify_compat_t;

typedef struct s3g_drawable_compat
{
    int server_index;
    unsigned int xId;
    s3g_clipnotify_compat_t clipNotify[MAX_SCREENS];
    int refCount;
}s3g_drawable_compat_t;

typedef struct
{
    int  type;            /* in */
    int  monitor_type;    /* out */
    int  monitor_width;   /* out */
    int  monitor_height;  /* out */
    int  connected;       /* output */

    int  edid_size;       /* output */
    compat_uptr_t edid;           /* output */

    int  mode_num;        /* output */
    compat_uptr_t modes;    /* output */

    int  _3dmode_num;     /* output */
    compat_uptr_t _3dmodes;       /* output */

    int  support_audio;   /* output */
}s3g_output_caps_compat_t;

typedef struct
{
    int crtc;
    compat_uptr_t  pLutBuf;
}s3g_gamma_info_compat_t;

typedef struct
{
    int server_index;
    int scrnIndex;
    int master;
    int samm;
    int mamm;
    int x;
    int y;
    int width;
    int height;
    int bpp;
    int pitch;
    unsigned int device;
    unsigned int hwFormat;
    int          rotate;
    int          gbd;
    int          use_rxa;
    int          bDuoView;
    compat_ulong_t fbOffset;
    unsigned int hAllocation;
}s3g_2d_screen_compat_t;

typedef struct
{
    unsigned int   len;  /* in */
    unsigned int   hSrcAllocation;   /* in */
    unsigned int   hDstAllocation;   /* in */
    unsigned int   hMaskAllocation;  /* in */
    unsigned int   kernel_mode_command;
    compat_uptr_t  cmd;  /* in */
}s3g_2d_draw_compat_t;

typedef struct
{
    unsigned int device;            /* in */
    unsigned int allocation;        /* in */
    unsigned int acquire_apeture :1;/* in */
    unsigned int read_only       :1;/* in */
    unsigned int write_only      :1;/* in */
    unsigned int cache_type      :3;/* in */

    compat_uptr_t virt_addr;        /* out */
}s3g_lock_allocation_compat_t;

typedef struct s3g_get_perf_event_tag_compat
{
    unsigned int max_event_num;             /* in */
    unsigned int max_event_buffer_size;     /* in */
    compat_uptr_t event_buffer;             /* in/out */
    unsigned int event_filled_num;          /* out */
    unsigned int event_buffer_filled_size;  /* out */
    unsigned int event_lost_num;            /* out */
    unsigned long long event_lost_timestamp;/* out */

    compat_uptr_t isr_event_buffer;         /* in/out */
    unsigned int isr_filled_num;            /* out */
    unsigned int isr_filled_size;           /* out */
} s3g_get_perf_event_compat_t;

typedef struct s3g_miu_reg_list_tag_compat
{
    unsigned int          miu_table_length;
    compat_uptr_t         miu_table;
}s3g_miu_reg_list_perf_event_compat_t;

typedef struct s3g_get_miu_dump_tag_compat
{
    unsigned int max_event_num;
    unsigned int max_event_buffer_size;
    compat_uptr_t event_buffer;
    unsigned int event_filled_num;
    unsigned int event_buffer_filled_size;
    unsigned int event_lost_num;
    unsigned long long event_lost_timestamp;
}s3g_get_miu_dump_perf_event_compat_t;

typedef struct s3g_direct_get_miu_dump_tag_compat
{
    compat_uptr_t miu_table;
    unsigned int        miu_table_length;
    unsigned int        timestamp_high;
    unsigned int        timestamp_low;
}s3g_direct_get_miu_dump_perf_event_compat_t;

typedef struct
{
    unsigned int  device;                   /* in   */
    unsigned int  engine_index;             /* in   */
    unsigned int  flags;                    /* in   */
    unsigned int  context;                  /* out  */
    compat_uptr_t command_buffer;           /* out  */
    unsigned int  command_buffer_size;      /* out  */
    compat_uptr_t allocation_list;          /* out  */
    unsigned int  allocation_list_size;     /* out  */
    compat_uptr_t patch_location_list;      /* out  */
    unsigned int  patch_location_list_size; /* out  */
    compat_uptr_t sync_object_list;         /* out  */
    unsigned int  sync_object_list_size;    /* out  */
}s3g_create_context_compat_t;

typedef struct
{
    unsigned int            context;                        /* in                   */
    unsigned int            command_length;                 /* in(number of bytes)  */
    unsigned int            command_offset;                 /* in                   */
    unsigned int            allocation_count;               /* in                   */
    unsigned int            patch_location_count;           /* in                   */
    unsigned int            sync_object_count;              /* in                   */
    compat_uptr_t           new_command_buffer;             /* out                  */
    unsigned int            new_command_buffer_size;        /* in/out               */
    compat_uptr_t           new_allocation_list;            /* out                  */
    unsigned int            new_allocation_list_size;       /* in/out               */
    compat_uptr_t           new_patch_location_list;        /* out                  */
    unsigned int            new_patch_location_list_size;   /* in/out               */
    unsigned int            flags;                          /* in                   */
}s3g_render_compat_t;

typedef struct
{
    unsigned int      dsi_index;
    unsigned int      virtual_ch;
    unsigned int      content_type;          /* 0: DCS cmd, 1:generic cmd */
    unsigned char     data_len;
    compat_uptr_t     data_buf;
    unsigned char     received_payload[16];
    unsigned char     payload_len;
    unsigned int      is_HSmode_only;        /* 0: both LP and HS mode, 1: only can be transferred in HS mode */
}s3g_dsi_read_cmd_compat_t;

typedef struct
{
    unsigned int      dsi_index;
    unsigned int      virtual_ch;
    unsigned int      packet_type;           /* 0: short packet, 1: long packet */
    unsigned int      content_type;          /* 0: DCS cmd, 1:generic cmd */
    unsigned short    data_len;
    compat_uptr_t     data_buf;
    unsigned int      is_need_ack;           /* 0: no need ack, 1: need ack */
    unsigned int      is_HSmode_only;        /* 0: both LP and HS mode, 1: only can be transferred in HS mode */
}s3g_dsi_write_cmd_compat_t;

typedef struct
{
    s3g_dsi_opcode    dsi_opcode;
    
    union
    {
        s3g_dsi_read_cmd_compat_t     read_cmd;
        s3g_dsi_write_cmd_compat_t    write_cmd;
    };
}s3g_dsi_cmd_compat_t;

typedef struct
{
    enum s3g_ipc_type           type;
    enum s3g_operation_type     operation;
    unsigned int                timeout;
    unsigned int                size_in;
    unsigned int                size_out;
    compat_uptr_t               send_data;
    compat_uptr_t               reply_data;
}s3g_ipc_operation_compat_t;

#endif
