/*
* Copyright 1998-2014 VIA Technologies, Inc. All Rights Reserved.
* Copyright 2001-2014 S3 Graphics, Inc. All Rights Reserved.
* Copyright 2013-2014 Shanghai Zhaoxin Semiconductor Co., Ltd. All Rights Reserved.
*
* This file is part of zx.ko
* 
* zx.ko is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* zx.ko is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#undef TRACE_SYSTEM
#define TRACE_SYSTEM s3gfx

#if !defined(_S3GFX_TRACE_H) || defined(TRACE_HEADER_MULTI_READ)
#define _S3GFX_TRACE_H

#include <linux/tracepoint.h>

TRACE_EVENT(s3gfx_fence_back,

    TP_PROTO(unsigned long jif_time, unsigned long engine_index, unsigned long long fence),

    TP_ARGS(jif_time, engine_index, fence),

    TP_STRUCT__entry(
        __field(unsigned long, jif_time)
        __field(unsigned long, engine_index)
        __field(unsigned long long, fence)
    ),

    TP_fast_assign(
        __entry->jif_time = jif_time;
        __entry->engine_index = engine_index;
        __entry->fence = fence;
    ),

    TP_printk("jif_time = %lu, engine_index = %lu, fence = %llu", __entry->jif_time, __entry->engine_index, __entry->fence)
);

TRACE_EVENT(s3gfx_cmd_render,

    TP_PROTO(unsigned long jif_time, unsigned long engine_index, void *context, unsigned long long render_counter),

    TP_ARGS(jif_time, engine_index, context, render_counter),

    TP_STRUCT__entry(
        __field(unsigned long, jif_time)
        __field(unsigned long, engine_index)
        __field(void *,        context)
        __field(unsigned long long, render_counter)
    ),

    TP_fast_assign(
        __entry->jif_time = jif_time;
        __entry->engine_index = engine_index;
        __entry->context      = context;
        __entry->render_counter = render_counter;
   ),

    TP_printk("jif_time = %lu, engine_index = %lu, context = %p, render_counter = %llu", __entry->jif_time, __entry->engine_index, __entry->context, __entry->render_counter)
);

TRACE_EVENT(s3gfx_dma_submit,

   TP_PROTO(unsigned long jif_time, unsigned long engine_index, void *context, unsigned long long render_counter, unsigned long long fence),

   TP_ARGS(jif_time, engine_index, context, render_counter, fence),

   TP_STRUCT__entry(
      __field(unsigned long, jif_time)
      __field(unsigned long, engine_index)
      __field(void *,        context)
      __field(unsigned long long, render_counter)
      __field(unsigned long long, fence)
   ),

   TP_fast_assign(
      __entry->jif_time = jif_time;
      __entry->engine_index = engine_index;
      __entry->context      = context;
      __entry->render_counter = render_counter;
      __entry->fence = fence;
   ),

   TP_printk("jif_time = %lu, engine_index = %lu, context = %p, render_counter = %llu, fence = %llu", __entry->jif_time, __entry->engine_index, __entry->context, __entry->render_counter, __entry->fence)
);

/* This part must be outside protection */
#undef TRACE_INCLUDE_PATH
#define TRACE_INCLUDE_PATH .
#define TRACE_INCLUDE_FILE s3gfx_trace
#include <trace/define_trace.h>

#endif

/*_S3GFX_TRACE_H */


